# Release notes for Gluster 10.1

This is a bugfix and improvement release. The release notes for [10.0](10.0.md) contain a listing of all the new features that were added and bugs fixed in the GlusterFS 10 stable release.

**NOTE:**
- Next minor release tentative date: Week of 15th Mar, 2022
- Users are highly encouraged to upgrade to newer releases of GlusterFS.

## Important fixes in this release
- Fix missing stripe count issue with upgrade from 9.x to 10.x
- Fix IO failure when shrinking distributed dispersed volume with ongoing IO
- Fix log spam introduced with glusterfs 10.0
- Enable ltcmalloc_minimal instead of ltcmalloc

## Builds are available at
https://download.gluster.org/pub/gluster/glusterfs/10/10.1/

## Bugs addressed
[#2846](https://github.com/gluster/glusterfs/issues/2846) Avoid redundant logs in gluster
[#2903](https://github.com/gluster/glusterfs/issues/2903) Fix worker disconnect due to AttributeError in geo-replication
[#2910](https://github.com/gluster/glusterfs/issues/2910) Check for available ports in port_range in glusterd
[#2939](https://github.com/gluster/glusterfs/issues/2939) Remove the deprecated commands from gluster man page
[#2947](https://github.com/gluster/glusterfs/issues/2947) Fix IO failure when shrinking distributed dispersed volume with ongoing IO
[#3071](https://github.com/gluster/glusterfs/issues/3071) Fix log spam introduced with glusterfs 10.0
[#3000](https://github.com/gluster/glusterfs/issues/3000) Enable ltcmalloc_minimal instead of ltcmalloc
[#3086](https://github.com/gluster/glusterfs/issues/3086) Handle excessive log in case dict is NUL
[#3133](https://github.com/gluster/glusterfs/issues/3066) Fix missing stripe count issue with upgrade from 9.x to 10.x
[#2962](https://github.com/gluster/glusterfs/issues/3066) Fix volume create failures without disperse count and ip addresses
