# Release notes for Gluster 10.2

This is a bugfix and improvement release. The release notes for [10.0](10.0.md) and [10.1](10.1.md) contain a listing of all the new features that were added and bugs fixed in the GlusterFS 10 stable release.

**NOTE:**
- Next minor release tentative date: Week of 15th Aug, 2022
- Users are highly encouraged to upgrade to newer releases of GlusterFS.

## Important fixes in this release
- Optimize server functionality by enhancing server_process_event_upcall code path during the handling of upcall event
- Fix all bricks not starting issue on node reboot when brick count is high(>750)
- Fix stale posix locks that appear after client disconnection

## Builds are available at
https://download.gluster.org/pub/gluster/glusterfs/10/10.2/

## Bugs addressed
[#3182](https://github.com/gluster/glusterfs/issues/3182) Fix stale posix locks that appear after client disconnection
[#3187](https://github.com/gluster/glusterfs/issues/3187) Fix Locks xlator fd leaks
[#3234](https://github.com/gluster/glusterfs/issues/3234) Fix incorrect directory check inorder to successfully locate the SSL certificate
[#3262](https://github.com/gluster/glusterfs/issues/3262) Synchronize layout_(ref|unref) during layout_(get|set) in dht
[#3321](https://github.com/gluster/glusterfs/issues/3321) Optimize server functionality by enhancing server_process_event_upcall code path during the handling of upcall event
[#3334](https://github.com/gluster/glusterfs/issues/3334) Fix errors and timeouts when creating qcow2 file via libgfapi
[#3375](https://github.com/gluster/glusterfs/issues/3375) Fix all bricks not starting issue on node reboot when brick count is high(>750)
[#3417](https://github.com/gluster/glusterfs/issues/3417) Fix crash due to unaligned memory access
[#3470](https://github.com/gluster/glusterfs/issues/3470) Fix spurious crash when "peer probing" a non existing host name
